"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class BirthClinicalQuestions(ProtocolElement):
    """
    Model that captures the clinical questions from birth.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import participant as participant_1_4_0

        return {
            "babyOralIntakeQuestions": participant_1_4_0.BabyOralIntakeQuestions,
            "durationOfLabour": participant_1_4_0.DurationOfLabour,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import participant as participant_1_4_0

        return {
            "deliveryComplications": participant_1_4_0.DeliveryComplications,
            "inducedBirth": participant_1_4_0.InducedBirth,
            "membraneStatus": participant_1_4_0.MembraneStatus,
            "modeOfDelivery": participant_1_4_0.ModeOfDelivery,
            "pretermLabour": participant_1_4_0.PretermLabour,
            "thirdStageOfLabour": participant_1_4_0.ThirdStageOfLabour,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import participant as participant_1_4_0

        return {
            "org.gel.models.participant.avro.BabyOralIntakeQuestions": participant_1_4_0.BabyOralIntakeQuestions,
            "org.gel.models.participant.avro.DeliveryComplications": participant_1_4_0.DeliveryComplications,
            "org.gel.models.participant.avro.DurationOfLabour": participant_1_4_0.DurationOfLabour,
            "org.gel.models.participant.avro.InducedBirth": participant_1_4_0.InducedBirth,
            "org.gel.models.participant.avro.MembraneStatus": participant_1_4_0.MembraneStatus,
            "org.gel.models.participant.avro.ModeOfDelivery": participant_1_4_0.ModeOfDelivery,
            "org.gel.models.participant.avro.PretermLabour": participant_1_4_0.PretermLabour,
            "org.gel.models.participant.avro.ThirdStageOfLabour": participant_1_4_0.ThirdStageOfLabour,
            "org.gel.models.participant.avro.BirthClinicalQuestions": participant_1_4_0.BirthClinicalQuestions,
        }

    __slots__ = [
        "babyOralIntakeQuestions",
        "dateAndTimeOfDelivery",
        "deliveryComplications",
        "durationOfLabour",
        "gravidaNumber",
        "inducedBirth",
        "membraneStatus",
        "modeOfDelivery",
        "mumsTimeSinceLastOralIntake",
        "numberOfBabiesDelivered",
        "parityNumber",
        "pregnancyTermWeeks",
        "pretermLabour",
        "thirdStageOfLabour",
    ]

    def __init__(
        self,
        babyOralIntakeQuestions=None,
        dateAndTimeOfDelivery=None,
        deliveryComplications=None,
        durationOfLabour=None,
        gravidaNumber=None,
        inducedBirth=None,
        membraneStatus=None,
        modeOfDelivery=None,
        mumsTimeSinceLastOralIntake=None,
        numberOfBabiesDelivered=None,
        parityNumber=None,
        pregnancyTermWeeks=None,
        pretermLabour=None,
        thirdStageOfLabour=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_4_0.BirthClinicalQuestions model.

        :param babyOralIntakeQuestions:
            Baby oral intake questions before sample (e.g. buccal swab, buccal
            sponge) was collected.
        :type babyOralIntakeQuestions: None | BabyOralIntakeQuestions
        :param dateAndTimeOfDelivery:
            String capturing the date and time of the delivery in ISO 8601 format
            with timezone and no microsecond.         format:
            %Y-%m-%dT%H:%M:%S+00:00         e.g.:
            2020-03-20T14:31:43+01:00
        :type dateAndTimeOfDelivery: None | str
        :param deliveryComplications:
            Delivery Complications.
        :type deliveryComplications: None | list[DeliveryComplications]
        :param durationOfLabour:
            Approximate duration of labour duration (this is the onset of regular
            contractions until delivery of placenta).
        :type durationOfLabour: None | DurationOfLabour
        :param gravidaNumber:
            Gravida Number - Gravida indicates the number of times a woman is or
            has been pregnant, regardless of the pregnancy outcome.
        :type gravidaNumber: None | int
        :param inducedBirth:
            Induced birth if any.
        :type inducedBirth: None | list[InducedBirth]
        :param membraneStatus:
            Membrane status.
        :type membraneStatus: None | list[MembraneStatus]
        :param modeOfDelivery:
            Mode of delivery.
        :type modeOfDelivery: None | list[ModeOfDelivery]
        :param mumsTimeSinceLastOralIntake:
            How long ago (in minutes) since mum had oral intake of food or fluids.
        :type mumsTimeSinceLastOralIntake: None | int
        :param numberOfBabiesDelivered:
            Number of babies delivered in this pregnancy.
        :type numberOfBabiesDelivered: None | int
        :param parityNumber:
            Parity Number - Parity, or "para", indicates the number of births
            (including live births and stillbirths) where pregnancies
            reached viable gestational age.
        :type parityNumber: None | int
        :param pregnancyTermWeeks:
            Pregnancy Term in weeks.
        :type pregnancyTermWeeks: None | int
        :param pretermLabour:
            Preterm labour if any.
        :type pretermLabour: None | list[PretermLabour]
        :param thirdStageOfLabour:
            Third stage - to establish if type of third stage impacts on the
            quantity of cord blood available for whole genome
            sequencing.
        :type thirdStageOfLabour: None | list[ThirdStageOfLabour]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.4.0"
